using System;
using System.Runtime.InteropServices;
using Decal.Interop.Net;

namespace Decal.Adapter.NetParser;

[ComVisible(true)]
[ClassInterface(ClassInterfaceType.None)]
[ComDefaultInterface(typeof(IMessageFactory))]
[ProgId("DecalAdapter.MessageFactory")]
[Guid("59D7815E-6716-4bd7-B264-69B6A9382701")]
public class MessageFactory : IMessageFactory
{
	IMessage2 IMessageFactory.CreateMessage(int pData, int size, bool outgoing)
	{
		if (pData != 0 && size != 0)
		{
			byte[] array = (byte[])Array.CreateInstance(typeof(byte), size);
			Marshal.Copy(new IntPtr(pData), array, 0, size);
			return new MessageWrapper(new Message(array, Message.GetParser(BitConverter.ToInt32(array, 0), outgoing ? MessageDirection.Outbound : MessageDirection.Inbound)));
		}
		return null;
	}
}
